package Web::Simple::Application::Role::Authentication;

use Plack::Request;
use Plack::Middleware::Session;
use Moo::Role;

requires '_ident_from_user';
requires '_user_from_ident';

## $_[PSGI_ENV] is setup by Web::Simple which we don't see here..
my $PSGI_ENV = -1;

sub set_authenticated {
  my ($self, $user) = @_;
  my $uc = $self->_ident_from_user($user);
  return (
    $self->ensure_session,
    sub () { $_[$PSGI_ENV]->{'psgix.session'}{'user_info'} = $uc; }
  );
}

sub check_authenticated {
  my ($self) = @_;
  my $user_ref = \$_[1];
  return (
    $self->ensure_session,
    sub () {
      if (my $uc = $_[$PSGI_ENV]->{'psgix.session'}{'user_info'}) {
        ${$user_ref} = $self->_user_from_ident($uc);
      }
      return;
    }
  );
}

sub _create_session {
  Plack::Middleware::Session->new(store => 'File');
}

sub ensure_session {
  my ($self) = @_;
  sub () {
    return if $_[$PSGI_ENV]->{'psgix.session'};
    $self->_create_session;
  }
}

1;
